//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * ボーンヘッダ
 * @author Junpee
 */

#ifndef BONE_H_
#define BONE_H_

#include <Core/Primitive/Axis3.h>
#include <Core/Container/ArrayList.h>

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * ボーン
 */
class Bone{
friend class CharacterModel;
public:
	//--------------------------------------------------------------------------
	/**
	 * ローカル行列の取得
	 * @return ローカル行列
	 */
	virtual const Matrix34& getLocalMatrix(){ return axis_.getMatrix(); }

	/**
	 * モデル行列の取得
	 * @return モデル行列
	 */
	virtual const Matrix34& getModelMatrix(){ return modelMatrix_; }

	/**
	 * 変形行列の取得
	 * @return 変形行列
	 */
	virtual const Matrix34& getDeformMatrix(){ return deformMatrix_; }

	//--------------------------------------------------------------------------
	/**
	 * ポーズ逆行列の設定
	 * @param inversePoseMatrix ポーズ逆行列
	 */
	virtual void setInversePoseMatrix(const Matrix34& inversePoseMatrix){
		inversePoseMatrix_ = inversePoseMatrix;
	}

	/**
	 * ポーズ逆行列の取得
	 * @return ポーズ逆行列
	 */
	virtual const Matrix34& getInversePoseMatrix() const{
		return inversePoseMatrix_;
	}

	//--------------------------------------------------------------------------
	/**
	 * スケールの設定
	 * @param scale スケール
	 */
	virtual void setScale(const Vector3& scale){ axis_.setScale(scale); }

	/**
	 * スケールの取得
	 * @return スケール
	 */
	virtual const Vector3& getScale() const{ return axis_.getScale(); }

	/**
	 * スケールを使用しているか
	 * @return スケールを使用しているならtrue
	 */
	virtual bool isScaled() const{ return axis_.isScaled(); }

	//--------------------------------------------------------------------------
	/**
	 * XYZ回転の設定
	 * @param rotation XYZ回転
	 */
	virtual void setRotationXYZ(const Vector3& rotation){
		axis_.setRotationXYZ(rotation);
	}

	/**
	 * XYZ回転の取得
	 * @return XYZ回転
	 */
	virtual const Vector3& getRotationXYZ(){
		return axis_.getRotationXYZ();
	}

	//--------------------------------------------------------------------------
	/**
	 * 四元数回転の設定
	 * @param rotation 四元数回転
	 */
	virtual void setRotationQuaternion(const Quaternion& rotation){
		axis_.setRotationQuaternion(rotation);
	}

	/**
	 * 四元数回転の取得
	 * @return 四元数回転
	 */
	virtual const Quaternion& getRotationQuaternion(){
		return axis_.getRotationQuaternion();
	}

	//--------------------------------------------------------------------------
	/**
	 * 移動の設定
	 * @param translation 移動
	 */
	virtual void setTranslation(const Vector3& translation){
		axis_.setTranslation(translation);
	}

	/**
	 * 移動の取得
	 * @return 移動
	 */
	virtual const Vector3& getTranslation() const{
		return axis_.getTranslation();
	}

	//--------------------------------------------------------------------------
	// ボーンインターフェース
	//--------------------------------------------------------------------------
	/**
	 * ボーンの追加
	 * @param bone 追加するボーン
	 */
	virtual void addBone(Bone* bone){
		bones_.add(bone);
	}

	/**
	 * ボーンの削除
	 * @param bone 削除するボーン
	 */
	virtual void removeBone(Bone* bone){
		bones_.removeByValue(bone);
	}

	/**
	 * ボーン数の取得
	 * @return ボーン数
	 */
	virtual int getBoneCount() const{ return bones_.getCount(); }

	/**
	 * ボーンの取得
	 * @param index インデックス
	 * @return ボーン
	 */
	virtual Bone* getBone(int index) const{
		Assert(index >= 0);
		Assert(index < getBoneCount());
		return bones_.get(index);
	}

	//--------------------------------------------------------------------------
	/**
	 * 名前の取得
	 * @return 名前
	 */
	virtual const String& getName() const{ return name_; }

	/**
	 * ボーンの値コピー
	 * @param destination コピー先ボーン
	 */
	virtual void copyBoneValue(Bone* destination) const;

	//--------------------------------------------------------------------------
protected:
	/**
	 * コンストラクタ
	 * @param name 名前
	 */
	Bone(const String& name);

	/**
	 * デストラクタ
	 */
	virtual ~Bone();

	//--------------------------------------------------------------------------
	/**
	 * ボーン行列の構築
	 * @param parentModelMatrix 親のモデル行列
	 * @return スケールが含まれていればtrue
	 */
	virtual bool buildBoneMatrix(const Matrix34& parentModelMatrix);

	//--------------------------------------------------------------------------
	/// 軸
	Axis3 axis_;
	/// ポーズ逆行列
	Matrix34 inversePoseMatrix_;
	/// モデル行列
	Matrix34 modelMatrix_;
	/// 変形行列
	Matrix34 deformMatrix_;
	/// ボーン配列
	ArrayList<Bone*> bones_;
	/// 名前
	String name_;

private:
	// コピーコンストラクタの隠蔽
	Bone(const Bone& copy);

	// 代入コピーの隠蔽
	void operator =(const Bone& copy);

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of BONE_H_
//------------------------------------------------------------------------------
